<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">

    <!-- bootstrap & jquery -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <script src="plugins/sweetalert2/sweetalert2.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Employees</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item dropdown mr-3">
                    <a class="nav-link" data-toggle="dropdown" href="#"><i class="fa-solid fa-user-large"></i></a>
                    <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
                        <span class="dropdown-item dropdown-header" id="user-info"></span>
                        <div class="dropdown-divider"></div>
                        <div class="text-center mt-2">
                            <button class="btn btn-danger" id="btn-log-out"><i
                                    class="fa-solid fa-right-from-bracket"></i> Log out</button>
                        </div>
                    </div>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="addressMap.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">ADMIN Real Estates</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="info text-white ml-2" id="username-info"></div>
                </div>
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class with font-awesome or any other icon font library -->
                        <li class="nav-item">
                            <a href="./addressMap.html" class="nav-link ">
                                <i class="fa-solid fa-map-location-dot"></i>
                                <p>
                                    Địa chỉ tọa độ
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./masterLayout.html" class="nav-link">
                                <i class="fa-solid fa-layer-group"></i>
                                <p>
                                    Mặt bằng tầng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./constructionContractor.html" class="nav-link ">
                                <i class="fa-solid fa-person-digging"></i>
                                <p>
                                    Nhà thầu xây dựng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./designUnit.html" class="nav-link ">
                                <i class="fa-solid fa-compass-drafting"></i>
                                <p>
                                    Đơn vị thiết kế
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./investor.html" class="nav-link">
                                <i class="fa-solid fa-user-tie"></i>
                                <p>
                                    Nhà đầu tư
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./regionLink.html" class="nav-link">
                                <i class="fa-solid fa-map"></i>
                                <p>
                                    Kết nối vùng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./utilities.html" class="nav-link">
                                <i class="fa-solid fa-person-swimming"></i>
                                <p>
                                    Tiện ích
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./customers.html" class="nav-link ">
                                <i class="fa-solid fa-users-line"></i>
                                <p>
                                    Khách hàng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./advise.html" class="nav-link">
                                <i class="fa-solid fa-comment-medical"></i>
                                <p>
                                    Thông tin KH cần tư vấn
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./employees.html" class="nav-link active">
                                <i class="fa-solid fa-user"></i>
                                <p>
                                    Người dùng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./project.html" class="nav-link">
                                <i class="fa-solid fa-hotel"></i>
                                <p>
                                    Dự án xây dựng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./realestate.html" class="nav-link">
                                <i class="fa-solid fa-city"></i>
                                <p>
                                    Thông tin BĐS
                                </p>
                            </a>
                        </li>
                        <li class="nav-item ">
                            <a href="#" class="nav-link">
                                <i class="fa-solid fa-bars"></i>
                                <p>
                                    Địa chính
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="./province.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Tỉnh thành</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./district.html" class="nav-link ">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Quận huyện</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./ward.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Phường xã</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./street.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Đường</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a href="./subscription.html" class="nav-link">
                                <i class="fa-solid fa-bell"></i>
                                <p>
                                    Subscription
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Employees</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <section class="content">
                <div class="container-fluid">
                    <h4 class="text-center form-group">Employees List</h4>
                    <div class="form-group">
                        <button class="btn btn-success" id="btn-create-new-employee"><i class="fa-solid fa-plus"></i>
                            Create New Employee</button>
                    </div>
                    <table class="table table-bordered table-striped table-hover" id="employee-table">
                        <thead>
                            <tr>
                                <th>Action</th>
                                <th>Employee ID</th>
                                <th>Last Name</th>
                                <th>First Name</th>
                                <th>Title</th>
                                <th>Title Of Courtesy</th>
                                <th>Birth Date</th>
                                <th>Hire Date</th>
                                <th>Address</th>
                                <th>City</th>
                                <th>Region</th>
                                <th>Postal Code</th>
                                <th>Country</th>
                                <th>Home Phone</th>
                                <th>Extension</th>
                                <th>Photo</th>
                                <th>Reports To</th>
                                <th>Username</th>
                                <th>Password</th>
                                <th>Email</th>
                                <th>Activated</th>
                                <th>Role</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>

                </div><!-- /.container-fluid -->
            </section>
            <!-- /.content -->

            <!-- Create new employee modal -->
            <div id="create-employee-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-success">
                            <h5 class="modal-title">Create New Employee</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Last Name<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-lastname" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>First Name<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-firstname" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Title</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-title" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Title Of Courtesy</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-TitleOfCourtesy" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>BirthDate</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-BirthDate" type="date" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>HireDate</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-HireDate" type="date" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Address</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-address" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>City</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-city" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Region</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-region" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>PostalCode</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-PostalCode" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Country</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-Country" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>HomePhone</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-HomePhone" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Extension</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-Extension" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Photo</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-Photo" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Notes</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-Notes" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>ReportsTo</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-ReportsTo" type="number" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Username<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-Username" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Password<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-Password" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Email<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-Email" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Activated</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-Activated" type="checkbox">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Profile</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-Profile" type="text" class="form-control">
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-primary" id="btn-create-confirm">Confirm</button>
                            <button class="btn btn-secondary" id="btn-create-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

            <!-- employee Detail modal -->
            <div id="employee-detail-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-success">
                            <h5 class="modal-title">Employee Details</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Last Name<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-lastname" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>First Name<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-firstname" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Title</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-title" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Title Of Courtesy</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-TitleOfCourtesy" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>BirthDate</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-BirthDate" type="date" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>HireDate</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-HireDate" type="date" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Address</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-address" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>City</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-city" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Region</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-region" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>PostalCode</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-PostalCode" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Country</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-Country" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>HomePhone</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-HomePhone" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Extension</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-Extension" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Photo</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-Photo" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Notes</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-Notes" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>ReportsTo</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-ReportsTo" type="number" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Username<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-Username" type="text" class="form-control" disabled>
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Password<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-Password" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Email<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-Email" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Activated</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-Activated" type="checkbox">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Profile</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-Profile" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Role</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <select id="update-select-role" class="form-control">
                                            <option value="4">DEFAULT</option>
                                            <option value="2">ADMIN</option>
                                            <option value="3">HOMESELLER</option>
                                        </select>
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-primary" id="btn-update-confirm">Update Confirm</button>
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Delete employee modal -->
            <div id="delete-employee-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-danger">
                            <h5 class="modal-title">Delete Employee Confirmation</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            Are you sure to delete this Employee?
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-delete-confirm">Confirm</button>
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

        </div>
        <!-- /.content-wrapper -->
        <footer class="main-footer">
            <strong>Copyright &copy; 2014-2021 Devcamp.</strong>
            All rights reserved.
            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 1.0.0
            </div>
        </footer>
    </div>

    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>

    <script>
        $(document).ready(function () {

            const token = getCookie("token");

            // Biến mảng toàn cục chứa danh sách tên các thuộc tính
            const gDATA_COLS = ["action", "employeeID", "lastName", "firstName", "title", "titleOfCourtesy", "birthDate", "hireDate", "address", "city", "region", "postalCode", "country", "homePhone", "extension", "photo", "reportsTo", "username", "password", "email", "activated", "roles[0].roleName"];

            // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
            const gACTION_COL = 0;
            const gID_COL = 1;
            const gLASTNAME_COL = 2;
            const gFIRSTNAME_COL = 3;
            const gTITLE_COL = 4;
            const gTITLEOFCOURTESY_COL = 5;
            const gBIRTHDATE_COL = 6;
            const gHIREDATE_COL = 7;
            const gADDRESS_COL = 8;
            const gCITY_COL = 9;
            const gREGION_COL = 10;
            const gPOSTALCODE_COL = 11;
            const gCOUNTRY_COL = 12;
            const gHOMEPHONE_COL = 13;
            const gEXTENSION_COL = 14;
            const gPHOTO_COL = 15;
            const gREPORTTO_COL = 16;
            const gUSERNAME_COL = 17;
            const gPASSWORD_COL = 18;
            const gEMAIL_COL = 19;
            const gACTIVATED_COL = 20;
            const gROLE_COL = 21;


            var gTable = $("#employee-table").DataTable({
                columns: [
                    { data: gDATA_COLS[gACTION_COL] },
                    { data: gDATA_COLS[gID_COL] },
                    { data: gDATA_COLS[gLASTNAME_COL] },
                    { data: gDATA_COLS[gFIRSTNAME_COL] },
                    { data: gDATA_COLS[gTITLE_COL] },
                    { data: gDATA_COLS[gTITLEOFCOURTESY_COL] },
                    { data: gDATA_COLS[gBIRTHDATE_COL] },
                    { data: gDATA_COLS[gHIREDATE_COL] },
                    { data: gDATA_COLS[gADDRESS_COL] },
                    { data: gDATA_COLS[gCITY_COL] },
                    { data: gDATA_COLS[gREGION_COL] },
                    { data: gDATA_COLS[gPOSTALCODE_COL] },
                    { data: gDATA_COLS[gCOUNTRY_COL] },
                    { data: gDATA_COLS[gHOMEPHONE_COL] },
                    { data: gDATA_COLS[gEXTENSION_COL] },
                    { data: gDATA_COLS[gPHOTO_COL] },
                    { data: gDATA_COLS[gREPORTTO_COL] },
                    { data: gDATA_COLS[gUSERNAME_COL] },
                    { data: gDATA_COLS[gPASSWORD_COL] },
                    { data: gDATA_COLS[gEMAIL_COL] },
                    { data: gDATA_COLS[gACTIVATED_COL] },
                    { data: gDATA_COLS[gROLE_COL] },
                ],
                "columnDefs": [
                    {
                        "targets": gACTION_COL,
                        "defaultContent": `<div class="row d-flex justify-content-center"><button class='btn btn-primary btn-detail-employee'><i class="fa-regular fa-pen-to-square"></i></button>
                                    <button class='btn btn-danger btn-delete-employee'><i class="fa-regular fa-trash-can"></i></button></div>`
                    }],
                scrollX: true,
            });

            var gId;
            var gEmployees = [];

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();

            //Set sự kiện cho nút logout
            $("#btn-log-out").on("click", function () {
                redirectToLogin();
            });

            // gán xự kiện nút tạo mới employee
            $("#btn-create-new-employee").on("click", function () {
                $("#create-employee-modal").modal("show");
            });

            // gán xự kiện  nút chi tiết employee
            $("#employee-table").on("click", ".btn-detail-employee", function () {
                onBtnDetailEmployeeClick(this);
            });

            // gán xự kiện  nút xóa employee
            $("#employee-table").on("click", ".btn-delete-employee", function () {
                onBtnDeleteEmployeeClick(this);
            });

            // gán xự kiện nút xác nhận tạo mới employee
            $("#btn-create-confirm").on("click", function () {
                onBtnCreateEmployeeConfirmClick();
            });

            // gán xự kiện nút xác nhận câp nhật employee
            $("#btn-update-confirm").on("click", function () {
                onBtnUpdateEmployeeConfirmClick();
            });

            // gán xự kiện  nút xác nhận xóa employee
            $("#btn-delete-confirm").on("click", function () {
                onBtnDeleteEmployeeConfirmClick();
            });

            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {
                "use strict";
                callApiGetUserIdByToken();
                callApiGetAllEmployees();
            }

            // Hàm xử lý khi nút xác nhận tạo mới employee được nhấn
            function onBtnCreateEmployeeConfirmClick() {
                "use strict";
                var vCreateData = {
                    lastName: "",
                    firstName: "",
                    title: "",
                    titleOfCourtesy: "",
                    birthDate: "",
                    hireDate: "",
                    address: "",
                    city: "",
                    region: "",
                    postalCode: "",
                    country: "",
                    homePhone: "",
                    extension: "",
                    photo: "",
                    notes: "",
                    reportsTo: "",
                    username: "",
                    password: "",
                    email: "",
                    activated: "",
                    profile: "",
                }
                // B1: Thu thập dữ liệu
                getCreateData(vCreateData);
                // B2: Kiểm tra dữ liệu
                var isValidate = validateCreateData(vCreateData);
                if (isValidate == true) {
                    // B3: xử lý hiển thị dữ liệu
                    callApiCreateNewEmployee(vCreateData);
                    // gọi lại tất cả employee
                    callApiGetAllEmployees();
                    // Ẩn modal
                    $("#create-employee-modal").modal("hide");
                    // clear dữ liệu trên modal
                    clearDataInCreateModal();
                }
            }

            // Hàm xử lý khi nút chi tiết employee được nhấn
            function onBtnDetailEmployeeClick(paramBtnDetail) {
                "use strict";
                // B1: Thu thập dữ liệu
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramBtnDetail).parents('tr');
                // Lấy các dữ liệu của hàng có cùng hàng với nút được nhấn
                var vDataRow = gTable.row(vRowSelected).data();
                console.log(vDataRow);
                gId = vDataRow.employeeID;
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu vào modal
                callApiGetEmployeeDataById();
                // Hiện modal
                $("#employee-detail-modal").modal("show");
            }

            // Hàm xử lý khi nút chi tiết employee được nhấn
            function onBtnDeleteEmployeeClick(paramBtnDetail) {
                "use strict";
                // B1: Thu thập dữ liệu
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramBtnDetail).parents('tr');
                // Lấy các dữ liệu của hàng có cùng hàng với nút được nhấn
                var vDataRow = gTable.row(vRowSelected).data();
                gId = vDataRow.employeeID;
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu vào modal
                // Hiện modal
                $("#delete-employee-modal").modal("show");
            }

            // Hàm xử lý khi nút xác nhận cập nhật employee được nhấn
            function onBtnUpdateEmployeeConfirmClick() {
                "use strict";
                var vUpdateData = {
                    lastName: "",
                    firstName: "",
                    title: "",
                    titleOfCourtesy: "",
                    birthDate: "",
                    hireDate: "",
                    address: "",
                    city: "",
                    region: "",
                    postalCode: "",
                    country: "",
                    homePhone: "",
                    extension: "",
                    photo: "",
                    notes: "",
                    reportsTo: "",
                    username: "",
                    password: "",
                    email: "",
                    activated: "",
                    profile: "",
                }
                // B1: Thu thập dữ liệu
                var vSelectRoleValue = $("#update-select-role").val();
                getUpdateData(vUpdateData);
                console.log(vUpdateData.activated)
                // B2: Kiểm tra dữ liệu
                var isValidate = validateUpdateData(vUpdateData);
                if (isValidate == true) {
                    // B3: xử lý hiển thị dữ liệu
                    callApiUpdateEmployee(vUpdateData, vSelectRoleValue);
                    // gọi lại tất cả employees
                    callApiGetAllEmployees();
                    // Ẩn modal
                    $("#employee-detail-modal").modal("hide");
                }
            }

            // Hàm xử lý khi nút xác nhận xóa employee được nhấn
            function onBtnDeleteEmployeeConfirmClick() {
                "use strict";
                // B1: Thu thập dữ liệu (bỏ qua)
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu
                callApiDeleteEmployee();
                // gọi lại tất cả employees
                callApiGetAllEmployees();
                // Ẩn modal
                $("#delete-employee-modal").modal("hide");
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            // Hàm load dữ liệu vào bảng
            function loadDataToTable(paramData) {
                "use strict";
                //Xóa toàn bộ dữ liệu đang có của bảng
                gTable.clear();
                //Cập nhật data cho bảng
                gTable.rows.add(paramData);
                //Cập nhật lại giao diện hiển thị bảng
                gTable.draw();
            }

            function callApiGetUserIdByToken() {
                $.ajax({
                    url: "http://localhost:8080/findUserId/Token",
                    type: 'GET',
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    headers: {
                        "Authorization": "Token " + token,
                    },
                    success: function (responseObject) {
                        //console.log(responseObject);
                        callApiGetEmployeeByID(responseObject);
                    },
                    error: function (pAjaxContext) {
                        //redirectToLogin();
                    }
                });
            }

            // Hàm gọi api lấy dữ liệu employee bằng id
            function callApiGetEmployeeByID(paramEmployeeId) {
                $.ajax({
                    url: "http://localhost:8080/employees/" + paramEmployeeId,
                    method: "GET",
                    async: false,
                    success: function (paramResponseObj) {
                        console.log(paramResponseObj);
                        handlerUserDataResponse(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            function handlerUserDataResponse(paramUserData) {
                $("#username-info").html(paramUserData.username);
                $("#user-info").html(paramUserData.username);
            }

            // Hàm gọi api lấy tất cả employee
            function callApiGetAllEmployees() {
                $.ajax({
                    url: "http://localhost:8080/employees",
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToTable(paramResponseObj);
                        gEmployees = paramResponseObj;
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api lấy dữ liệu employee bằng id
            function callApiGetEmployeeDataById() {
                $.ajax({
                    url: "http://localhost:8080/employees/" + gId,
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataOnDetailModal(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api tạo employee
            function callApiCreateNewEmployee(paramCreateData) {
                $.ajax({
                    url: "http://localhost:8080/employees",
                    method: "POST",
                    async: false,
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(paramCreateData),
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Success.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Failed.");
                    }
                });
            }

            // Hàm gọi api cập nhật employee
            function callApiUpdateEmployee(paramUpdateData, paramRole) {
                $.ajax({
                    url: "http://localhost:8080/employees/" + gId + "/role/" + paramRole,
                    method: "PUT",
                    async: false,
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(paramUpdateData),
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Success.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Failed.");
                    }
                });
            }

            // Hàm gọi api xóa employee
            function callApiDeleteEmployee() {
                $.ajax({
                    url: "http://localhost:8080/employees/" + gId,
                    method: "DELETE",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Success.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Failed.");
                    }
                });
            }

            // Hàm thu thập dữ liệu để tạo employee
            function getCreateData(paramCreateData) {
                "use strict";
                paramCreateData.lastName = $("#create-input-lastname").val().trim();
                paramCreateData.firstName = $("#create-input-firstname").val().trim();
                paramCreateData.title = $("#create-input-title").val().trim();
                paramCreateData.titleOfCourtesy = $("#create-input-TitleOfCourtesy").val().trim();
                paramCreateData.birthDate = $("#create-input-BirthDate").val().trim();
                paramCreateData.hireDate = $("#create-input-HireDate").val().trim();
                paramCreateData.address = $("#create-input-address").val().trim();
                paramCreateData.city = $("#create-input-city").val().trim();
                paramCreateData.region = $("#create-input-region").val().trim();
                paramCreateData.postalCode = $("#create-input-PostalCode").val().trim();
                paramCreateData.country = $("#create-input-Country").val().trim();
                paramCreateData.homePhone = $("#create-input-HomePhone").val().trim();
                paramCreateData.extension = $("#create-input-Extension").val().trim();
                paramCreateData.photo = $("#create-input-Photo").val().trim();
                paramCreateData.notes = $("#create-input-Notes").val().trim();
                paramCreateData.reportsTo = $("#create-input-ReportsTo").val().trim();
                paramCreateData.username = $("#create-input-Username").val().trim();
                paramCreateData.password = $("#create-input-Password").val().trim();
                paramCreateData.email = $("#create-input-Email").val().trim();
                paramCreateData.profile = $("#create-input-Profile").val().trim();
                if($("#create-input-Activated").is(':checked')){
                    paramCreateData.activated = "Y";
                } else {
                    paramCreateData.activated = "N";
                }
            }

            // Hàm thu thập dữ liệu để cap nhat employee
            function getUpdateData(paramUpdateData) {
                "use strict";
                paramUpdateData.lastName = $("#update-input-lastname").val().trim();
                paramUpdateData.firstName = $("#update-input-firstname").val().trim();
                paramUpdateData.title = $("#update-input-title").val().trim();
                paramUpdateData.titleOfCourtesy = $("#update-input-TitleOfCourtesy").val().trim();
                paramUpdateData.birthDate = $("#update-input-BirthDate").val().trim();
                paramUpdateData.hireDate = $("#update-input-HireDate").val().trim();
                paramUpdateData.address = $("#update-input-address").val().trim();
                paramUpdateData.city = $("#update-input-city").val().trim();
                paramUpdateData.region = $("#update-input-region").val().trim();
                paramUpdateData.postalCode = $("#update-input-PostalCode").val().trim();
                paramUpdateData.country = $("#update-input-Country").val().trim();
                paramUpdateData.homePhone = $("#update-input-HomePhone").val().trim();
                paramUpdateData.extension = $("#update-input-Extension").val().trim();
                paramUpdateData.photo = $("#update-input-Photo").val().trim();
                paramUpdateData.notes = $("#update-input-Notes").val().trim();
                paramUpdateData.reportsTo = $("#update-input-ReportsTo").val().trim();
                paramUpdateData.username = $("#update-input-Username").val().trim();
                paramUpdateData.password = $("#update-input-Password").val().trim();
                paramUpdateData.email = $("#update-input-Email").val().trim();
                paramUpdateData.profile = $("#update-input-Profile").val().trim();
                if($("#update-input-Activated").is(':checked')){
                    paramUpdateData.activated = "Y";
                } else {
                    paramUpdateData.activated = "N";
                }
            }

            // Hàm kiểm tra dữ liệu để tạo employee
            function validateCreateData(paramCreateData) {
                "use strict";
                if (paramCreateData.lastName == "") {
                    alertError("Last Name không được để trống");
                    return false;
                }
                if (paramCreateData.firstName == "") {
                    alertError("First Name không được để trống");
                    return false;
                }
                for (let i = 0; i < gEmployees.length; i++) {
                    if (paramCreateData.username == gEmployees[i].username) {
                        alertError("User Name đã tồn tại.");
                        return false;
                    }
                }
                if (paramCreateData.username == "") {
                    alertError("User Name không được để trống");
                    return false;
                }
                if (paramCreateData.password == "") {
                    alertError("Password không được để trống");
                    return false;
                }
                if (paramCreateData.email == "") {
                    alertError("Email không được để trống");
                    return false;
                }
                return true;
            }

            // Hàm kiểm tra dữ liệu để cap nhat employee
            function validateUpdateData(paramUpdateData) {
                "use strict";
                if (paramUpdateData.lastName == "") {
                    alertError("Last Name không được để trống");
                    return false;
                }
                if (paramUpdateData.firstName == "") {
                    alertError("First Name không được để trống");
                    return false;
                }
                if (paramUpdateData.password == "") {
                    alertError("Password không được để trống");
                    return false;
                }
                if (paramUpdateData.email == "") {
                    alertError("Email không được để trống");
                    return false;
                }
                return true;
            }

            // Xóa trắng dữ liệu trong form create modal
            function clearDataInCreateModal() {
                $("#create-input-lastname").val("");
                $("#create-input-firstname").val("");
                $("#create-input-title").val("");
                $("#create-input-TitleOfCourtesy").val("");
                $("#create-input-BirthDate").val("");
                $("#create-input-HireDate").val("");
                $("#create-input-address").val("");
                $("#create-input-city").val("");
                $("#create-input-region").val("");
                $("#create-input-PostalCode").val("");
                $("#create-input-Country").val("");
                $("#create-input-HomePhone").val("");
                $("#create-input-Extension").val("");
                $("#create-input-Photo").val("");
                $("#create-input-Notes").val("");
                $("#create-input-ReportsTo").val("");
                $("#create-input-Username").val("");
                $("#create-input-Password").val("");
                $("#create-input-Email").val("");
                $("#create-input-Activated").val("");
                $("#create-input-Profile").val("");
            }

            // load dữ liệu vào form trên detail modal
            function loadDataOnDetailModal(paramRowData) {
                $("#update-input-lastname").val(paramRowData.lastName);
                $("#update-input-firstname").val(paramRowData.firstName);
                $("#update-input-title").val(paramRowData.title);
                $("#update-input-TitleOfCourtesy").val(paramRowData.titleOfCourtesy);
                $("#update-input-BirthDate").val(paramRowData.birthDate);
                $("#update-input-HireDate").val(paramRowData.hireDate);
                $("#update-input-address").val(paramRowData.address);
                $("#update-input-city").val(paramRowData.city);
                $("#create-input-region").val(paramRowData.region);
                $("#update-input-PostalCode").val(paramRowData.postalCode);
                $("#update-input-Country").val(paramRowData.country);
                $("#update-input-HomePhone").val(paramRowData.homePhone);
                $("#update-input-Extension").val(paramRowData.extension);
                $("#update-input-Photo").val(paramRowData.photo);
                $("#update-input-Notes").val(paramRowData.notes);
                $("#update-input-ReportsTo").val(paramRowData.reportsTo);
                $("#update-input-Username").val(paramRowData.username);
                $("#update-input-Password").val(paramRowData.password);
                $("#update-input-Email").val(paramRowData.email);
                $("#update-input-Activated").val(paramRowData.activated);
                $("#update-input-Profile").val(paramRowData.profile);
            }

            function redirectToLogin() {
                // Trước khi logout cần xóa token đã lưu trong cookie
                setCookie("token", "", 1);
                window.location.href = "index.html";
            }

            //Hàm get Cookie
            function getCookie(cname) {
                var name = cname + "=";
                var decodedCookie = decodeURIComponent(document.cookie);
                var ca = decodedCookie.split(';');
                for (var i = 0; i < ca.length; i++) {
                    var c = ca[i];
                    while (c.charAt(0) == ' ') {
                        c = c.substring(1);
                    }
                    if (c.indexOf(name) == 0) {
                        return c.substring(name.length, c.length);
                    }
                }
                return "";
            }

            //Hàm setCookie đã giới thiệu ở bài trước
            function setCookie(cname, cvalue, exdays) {
                var d = new Date();
                d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
                var expires = "expires=" + d.toUTCString();
                document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
            }

              // Hàm alert success
              function alertSuccess(paramTitle) {
                "use strict";
                $(function () {
                    var Toast = Swal.mixin({
                        toast: false,
                        position: 'top',
                        showConfirmButton: false,
                        timer: 3500
                    });
                    Toast.fire({
                        icon: 'success',
                        title: paramTitle,
                    })
                });
            }

            // Hàm alert lỗi
            function alertError(paramTitle) {
                "use strict";
                $(function () {
                    var Toast = Swal.mixin({
                        toast: false,
                        position: 'top',
                        showConfirmButton: false,
                        timer: 3500
                    });
                    Toast.fire({
                        icon: 'error',
                        title: paramTitle,
                    })
                });
            }

        });

    </script>
</body>